#include <QDialog>
#include <QTimer>
#include <QSerialPort>
#include <QSerialPortInfo>
#include <QDebug>
#include "actuadorVoltage.h"
#include "ui_actuadorVoltage.h"

using namespace std;

actuadorVoltage::actuadorVoltage(int minimo,int maximo,QSerialPort **arduinos,QWidget *parent):
    QDialog(parent),analogActuador(minimo,maximo),
    ui(new Ui::actuadorVoltage)

{
    arduino = arduinos;
    ui->setupUi(this);
    scene = new QGraphicsScene(this);
    connect(ui->horizontalScrollBar,SIGNAL(valueChanged(int)),this,SLOT(setPWM(int)));
    connect(this,SIGNAL(emisionMovimientoSlider(int)),ui->lcdNumber,SLOT(display(int)));

}

actuadorVoltage::~actuadorVoltage()
{
    delete ui;
}


void actuadorVoltage::setPWM(int pwm) { //de 0 a 100
    //short int cm = (short int)pwm;
   // char enviochar = 0xFF&pwm; //maximo valor de pwm es 100 asi que no es necesario considerar los 3 siguientes bytes del valor int
    QByteArray envio;
    double aux = min + (pwm*(max - min)/100.0);//unicamente con el proposito de mostrar
    envio.setNum(pwm);
    envio.append("\n");
    //envio[0] = enviochar;
    emit emisionMovimientoSlider((int)aux);
    //qDebug() <<envio<<endl;
    if((*arduino)->isWritable()){
        (*arduino)->write(envio);
    }

}

QString & actuadorVoltage::getUnidades(){
    return analogActuador::getUnidades();

}

QString & actuadorVoltage::getNombre(){
    return analogActuador::getNombre();

}

void actuadorVoltage::setLabels() {
    //ui->lbl_tipo->setText(tipo);
    ui->lbl_unit->setText(this->getUnidades());
    ui->lbl_variable->setText(this->getNombre());
}
