#include "analogVoltage.h"
#include "ui_analogVoltage.h"
#include <QTimer>
#include <QSerialPort>
#include <QSerialPortInfo>
#include <QDebug>


using namespace std;

analogVoltage::analogVoltage(QString & unidad,QString & nombre,QWidget *parent) :
    QDialog(parent),analogSensor(unidad,nombre),
    ui(new Ui::analogVoltage)
{
    ui->setupUi(this);
    //scene = new QGraphicsScene(this);
    //QTimer *timerRefresh = new QTimer(this);
    //connect(timerRefresh, SIGNAL(timeout()), this, SLOT(refreshLcd()));
    //connect(timerRefresh, SIGNAL(timeout()), this, SLOT(refreshGraph()));
    connect(ui->closeB,SIGNAL(clicked()),this,SLOT(termino()));
    //timerRefresh->start(100);
    //arduino = arduinos;
    //---qCustomplot
//    ui->w_grafico = new QCustomPlot(this);
//    ui->w_grafico->yAxis->setLabel(unidad);
//    ui->w_grafico->xAxis->setLabel("tiempo");
//    mGraph1 = ui->w_grafico->addGraph();

//    ui->w_grafico = new QCustomPlot();
//    ui->w_grafico->axisRect()->setMinimumSize(300, 180);
//    mGraph1 = ui->w_grafico->addGraph();
//    ui->w_grafico->graph(0)->setPen(QPen(Qt::blue));
//    ui->w_grafico = new QCustomPlot();
//    ui->w_grafico->axisRect()->setMinimumSize(300, 180);
//    mGraph1 = ui->w_grafico->addGraph();
    //ui->w_grafico->graph(0)->setPen(QPen(Qt::blue));
    // generate some data:
    QVector<double> x(1), y(1); // initialize with entries 0..100
//    for (int i=0; i<101; ++i)
//    {
//      x[i] = i/50.0 - 1; // x goes from -1 to 1
//      y[i] = x[i]*x[i]; // let's plot a quadratic function
//    }
    x[0]=0;
    y[0]=0;
    // create graph and assign data to it:
    mGraph1 = ui->w_grafico->addGraph();
     ui->w_grafico->graph(0)->setData(x, y);
     if(unidad == "%"){
         cteHumedad=0.1;
     }
     else{
         cteHumedad=1;
     }
    // give the axes some labels:
    ui->w_grafico->xAxis->setLabel("tiempo");
    ui->w_grafico->yAxis->setLabel(unidad);
    // set axes ranges, so we see all data:
//    ui->w_grafico->xAxis->setRange(-1, 1);
//    ui->w_grafico->yAxis->setRange(0, 1);
    ui->w_grafico->replot();

}

Ui::analogVoltage * analogVoltage::getUI(){
    return ui;
}

QString & analogVoltage::getUnidades(){
    return analogSensor::getUnidades();

}

QString & analogVoltage::getNombre(){
    return analogSensor::getNombre();

}

void analogVoltage::setLabels(){
    //ui->setupUi(this);
    //scene = new QGraphicsScene(this);
    //ui->label_3->repaint();
    //ui->label_variable_2->repaint();
    //qApp->processEvents();
    //ui->lbl_units->setText(this->getUnidades());
    ui->lbl_tipo->setText(tipo);
    ui->lbl_units->setText(this->getUnidades());
    ui->lbl_variable->setText(this->getNombre());
}

analogVoltage::~analogVoltage()
{
    delete ui;
    //delete data;
    //delete arduino;
}

void analogVoltage::termino() {
    close();
}

int analogVoltage::getDato() {
    return datoLeido;
}


void analogVoltage::setSensorValue(int valor)
{
    datoLeido = valor;
    refreshLcd();
    refreshGraph();
}

void analogVoltage::refreshLcd()
{
    //(*arduino)->write("3\n");
    //if((*arduino)->isReadable()){
           // QByteArray datoLeido = arduino->read(2);
        //datoLeido = (*arduino)->readAll();
           // int DatoEntero = datoLeido.toHex().toInt(0,16);
            //qDebug() << datoLeido;
        ui->lcdAnalogValue->display(getDato());
    //}

}

void analogVoltage::refreshGraph(){
    //ui->graphicsView->setScene(scene);
    //QPen outlinePen(Qt::black);
    //outlinePen.setWidth(2);

    x1 = x2;
    y1 = y2;
    x2 = x2 + 1;
    y2 = -0.2*datoLeido;

    //qDebug() << x2;
//    addLine(qreal x1, qreal y1, qreal x2, qreal y2, const QPen &pen = QPen())
    //line = scene->addLine(x1,y1,x2,y2,outlinePen);
    //---qcustomPlot
//    mGraph1->addData(mGraph1->dataCount(), datoLeido);
//    ui->w_grafico->xAxis->rescale();
//    mGraph1->rescaleValueAxis(false, true);
//    ui->w_grafico->replot();
    ui->w_grafico->graph(0)->addData((((double) mGraph1->dataCount())* deltaT), ((double) datoLeido)*cteHumedad);
    ui->w_grafico->graph(0)->rescaleAxes();
    ui->w_grafico->replot();
}

void analogVoltage::setDeltaT(int delta)
{
    switch (delta) {
    case 500:
        deltaT = 0.5;
        break;
    case 100:
        deltaT = 0.1;
        break;
    case 50:
        deltaT = 0.05;
        break;
    default:
        break;
    }
}

