#ifndef ANALOGVOLTAGE_H
#define ANALOGVOLTAGE_H

#include <QDialog>
#include <QGraphicsScene>
#include <QGraphicsView>
#include <QGraphicsItem>
#include "AnalogSensor.h"
#include "qcustomplot.h"

void delay(int seconds);

namespace Ui {
class analogVoltage;
}

class QSerialPort;

class analogVoltage : public QDialog, public analogSensor
{
    Q_OBJECT

public:
    explicit analogVoltage(QString &,QString &,QWidget *parent = nullptr);
    ~analogVoltage();
    virtual QString & getUnidades();
    virtual QString & getNombre();
    virtual void setLabels();
    Ui::analogVoltage * getUI();
    virtual int getDato();
    void setSensorValue(int);


//public slots:
    void refreshLcd();
    void refreshGraph();
    void setDeltaT(int delta);
public slots:
    void termino();
protected:
    Ui::analogVoltage *ui;
    int datoLeido;
    QString tipo = "Sensor";
private:
    //QSerialPort **arduino;
    QGraphicsScene *scene;
    QGraphicsLineItem *line;
    int y1,y2 = 0;
    int x1,x2 = -400;
    //int * actividad;
    //QCustomPlot *mPlot;
    QPointer<QCPGraph> mGraph1;
    double deltaT;
    double cteHumedad;
};

#endif
