#include <Servo.h> //incluye libreria de servo

const byte PWM_PIN_OUT = 6;
const byte SERVO_ATTACH_PIN = 9;
const int ANLG_IN_PIN = A7;
const int MAX_VECTOR_LENGTH = 20;
const char ANLG_QRTY = '?';

String cadenaCharEntrada = "";  
char vectorChar[MAX_VECTOR_LENGTH];
bool finCadena, flag, fg_qry, fg_setPwm;

Servo myservo;  // crea objeto servo

void setup() {
  Serial.begin(9600);
  cadenaCharEntrada.reserve(MAX_VECTOR_LENGTH);
  pinMode(PWM_PIN_OUT,OUTPUT);
  myservo.attach(SERVO_ATTACH_PIN); //se le asigna el pin 9
  finCadena = false;
  flag = false;
  fg_qry = false;
  fg_setPwm = false;
}

void loop() { 
  int val, numeroEntero;
  val = 0;
  if(finCadena){                               //Se termino de recibir una cadena completa
    finCadena = false;                                  //Permitimos volver a recibir otra cadena
    cadenaCharEntrada.toCharArray(vectorChar,MAX_VECTOR_LENGTH);   //Convertimos el string a un vectorChar
    numeroEntero = atoi(vectorChar);            //Convertimos un vectorChar a un entero
       
    if(fg_setPwm == true){
      analogWrite(PWM_PIN_OUT,numeroEntero);
    }
    else{
      analogWrite(PWM_PIN_OUT,0);
    }
    if(fg_qry){
      Serial.print(analogRead(ANLG_IN_PIN));
    }
    cadenaCharEntrada = "";
    val = numeroEntero;            //lee valor serial (entre 0 and 1000)
    val = map(val, 0, 100, 0, 180);     // lo escala (valores entre 0 y 180)
    myservo.write(val);                  // setea el valor
  }
  
}

void serialEvent(){
  //Recepción de datos Seriales por evento
  char CaracterEntrada;
  while (Serial.available()) {              //Si existen datos seriales, leer a todos
    CaracterEntrada = Serial.read();   //Leer 1 byte serial recibido
   
    cadenaCharEntrada += CaracterEntrada;   //Agregar el nuevo char a una cadena String 
    if (CaracterEntrada == '\n') {          //Si el char o byte recibido es un fin de linea, activa la bandera
      finCadena = true;                        //Si la bandera finCadena = 1, entonces la transmision esta completa
    }
    if (CaracterEntrada == '?')
      fg_qry = true;
    if (CaracterEntrada == 's')
      fg_setPwm = true;
    
  }
  
}
