/**
  * @file serialconfigdialog.cpp
  * @version 0.1
  * @date 17/02/2020
  * @author Cristian Herrera L.
  * @brief Clase serialConfigDialog que permite configurar los parámetros
  * de la comunicación serial en una nueva ventana.
  *
  */

#include "configanalogactuador.h"
#include "ui_configanalogactuador.h"

ConfigAnalogActuador::ConfigAnalogActuador(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::ConfigAnalogActuador)
{
    ui->setupUi(this);
    //Se configuran las oipciones de los comboBoxes
    //Se setean las opciones del tipo de sensor
    ui->cB_actuadorType->addItem("Servo");
    ui->cB_actuadorType->addItem("Motor");
    ui->cB_actuadorType->addItem("Leds");

}

ConfigAnalogActuador::~ConfigAnalogActuador()
{
    delete ui;
}

std::string ConfigAnalogActuador::getTipoActuador()
{
    //QString m = "";
    //QString * aux;// = m;
    //aux = (malloc(QString))*;
    //aux= (ui->cB_sensorType->currentText());
    return (ui->cB_actuadorType->currentText()).toStdString();
}


void ConfigAnalogActuador::on_buttonBox_accepted()
{
    accept();
}

void ConfigAnalogActuador::on_buttonBox_rejected()
{
    reject();
}

