/**
  * @file serialconfigdialog.cpp
  * @version 0.1
  * @date 17/02/2020
  * @author Sebastián Arriagada C.
  * @brief Clase serialConfigDialog que permite configurar los parámetros
  * de la comunicación serial en una nueva ventana.
  *
  */

#include "configanalogsensordialog.h"
#include "ui_configanalogsensordialog.h"

ConfigAnalogSensorDialog::ConfigAnalogSensorDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::ConfigAnalogSensorDialog)
{
    ui->setupUi(this);
    //Se configuran las oipciones de los comboBoxes
    //Se setean las opciones del tipo de sensor
    ui->cB_sensorType->addItem("Humedad");
    ui->cB_sensorType->addItem("Luz");
    ui->cB_sensorType->addItem("Fuerza");
    ui->cB_sensorType->addItem("Corriente");
    //Se setean el periodo de muestreo
    ui->cB_refreshPeriod->addItem("50[ms]");
    ui->cB_refreshPeriod->addItem("100[ms]");
    ui->cB_refreshPeriod->addItem("500[ms]");

}

ConfigAnalogSensorDialog::~ConfigAnalogSensorDialog()
{
    delete ui;
}

std::string ConfigAnalogSensorDialog::getTipoSensor()
{
    //QString m = "";
    //QString * aux;// = m;
    //aux = (malloc(QString))*;
    //aux= (ui->cB_sensorType->currentText());
    return (ui->cB_sensorType->currentText()).toStdString();
}

std::string  ConfigAnalogSensorDialog::getTs()
{
    return (ui->cB_refreshPeriod->currentText()).toStdString();
}


void ConfigAnalogSensorDialog::on_buttonBox_accepted()
{
    accept();
}

void ConfigAnalogSensorDialog::on_buttonBox_rejected()
{
    reject();
}

