#include "mainwindow.h"
#include "ui_mainwindow.h"
//<<<<<<< Updated upstream
//#include <analogsensordialog.h>
//#include <QtSerialPort/QtSerialPort>
//#include <QtSerialPort/QSerialPortInfo>
//=======
#include <QtSerialPort>
#include <QSerialPortInfo>
//>>>>>>> Stashed changes
#include <QTimer>
#include <QDebug>
#include <QMessageBox>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);
//    QTextDocument *code = new QTextDocument;
//    QString arduinoCode;
//    code->addResource(QTextDocument::UnknownResource, QUrl("./arduinoCode.txt"), QVariant(arduinoCode));
    serialCom = new QSerialPort;
    flag = false;
    QString inicial = " ";
    SensorAnalogo = new analogVoltage(inicial,inicial);
    ActuadorAnalogo = new actuadorVoltage(0,100,&serialCom);
    timerRefresh = new QTimer(this);
    timerRefresh->start(500);
    connect(timerRefresh, SIGNAL(timeout()), this, SLOT(digestSerialData()));
    foreach (const QSerialPortInfo &serialPortInfo, QSerialPortInfo::availablePorts()){
        ui->cB_puertos->addItem(serialPortInfo.portName());
    }
    //ui->pTE_arduinoCode-> // loadResource(QTextDocument::UnknownResource, QUrl("arduinoCode.txt"));

}

MainWindow::~MainWindow()
{
    delete ui;
    delete serialCom;
    delete SensorAnalogo;
    delete ActuadorAnalogo;
    delete configuracionSensor;
    delete timerRefresh;
    delete configuracionActuador;
}


void MainWindow::on_actionSensor_An_logo_Gen_rico_triggered()
{
    SensorAnalogo->setLabels();
    SensorAnalogo->show();
    flag = true;
/*<<<<<<< Updated upstream

=======
    
>>>>>>> Stashed changes
*/
}

void MainWindow::on_actionConfigSensorAnalogo_triggered() {
    QString uni;
    QString nomb;
    std::string hum = "Humedad";
    std::string luz = "Luz";
    std::string fuerza = "Fuerza";
    std::string corriente = "Corriente";

    std::string m1 = "50[ms]";
    std::string m2 = "100[ms]";
    std::string m3 = "500[ms]";

    int returnConfigAnalogSensorDialog;
    ConfigAnalogSensorDialog newSensorConfig(this);
    configuracionSensor = &newSensorConfig;
    newSensorConfig.setWindowTitle("Sensor");
    returnConfigAnalogSensorDialog = newSensorConfig.exec();
    if (returnConfigAnalogSensorDialog == QDialog::Rejected)
        return;
    tipo_sensor = configuracionSensor->getTipoSensor();
    periodo = configuracionSensor->getTs();
    QString qstr = QString::fromStdString(tipo_sensor);

    if(periodo == m1) {
        timerRefresh->setInterval(50);
        delta = 50;
    }
    if(periodo == m2){
        timerRefresh->setInterval(100);
        delta = 100;
    }
    if(periodo == m3){
        timerRefresh->setInterval(500);
        delta = 500;
    }


    if (tipo_sensor == hum) {
        uni = "%";
        nomb = "Regador";
        SensorAnalogo = new humedadSensor(uni,nomb);
    }
    else if(tipo_sensor == luz){
        uni = "lumenes";
        nomb = "Lampara";
        SensorAnalogo = new luzSensor(uni,nomb);
    }
    else if(tipo_sensor == corriente) {
        uni = "[A]";
        nomb = "corriente en cable";
        SensorAnalogo = new corrienteSensor(uni,nomb);
    }
    else if(tipo_sensor == fuerza) {
        uni = "[N]";
        nomb = "Peso";
        SensorAnalogo = new fuerzaSensor(uni,nomb);
    }
    SensorAnalogo->setDeltaT(delta);
}



void MainWindow::defaultSerialConfig()
{
    serialCom->setBaudRate(QSerialPort::Baud9600);
    serialCom->setDataBits(QSerialPort::Data8);
    serialCom->setParity(QSerialPort::NoParity);
    serialCom->setStopBits(QSerialPort::OneStop);
    serialCom->setFlowControl(QSerialPort::NoFlowControl);
}

void MainWindow::manualSerialConfig()
{
    serialCom->setBaudRate(bR);
    serialCom->setDataBits((QSerialPort::DataBits)(dB));
    serialCom->setParity((QSerialPort::Parity)(pty));
    serialCom->setStopBits((QSerialPort::StopBits)(sB));
    serialCom->setFlowControl((QSerialPort::FlowControl)(fC));
}

//<<<<<<< Updated upstream
void MainWindow::refreshAnalogSensor()
{
    SensorAnalogo->setSensorValue(msgRcvd_byteArray.toInt());
}

void MainWindow::digestSerialData()
{
    if(serialCom->isWritable()&&flag){
        serialCom->write("?\n");//1000
        if(serialCom->isReadable()){
            msgRcvd_byteArray = serialCom->readAll();
            refreshAnalogSensor();
        }

    }



}

void MainWindow::on_actionserial_triggered()
{
    int returnSerialConfigDialog;
    serialConfigDialog newSerialConfig(this);
    newSerialConfig.setWindowTitle("Configuracion serial");//RRR:agregar el com q se está programando ej:COM5

    returnSerialConfigDialog = newSerialConfig.exec();
    if (returnSerialConfigDialog == QDialog::Rejected)
        return;
    bR = newSerialConfig.getBaudRate();
    dB = newSerialConfig.getDatabit();
    pty = newSerialConfig.getParity();
    sB = newSerialConfig.getStopBit();
    fC = newSerialConfig.getFlowControl();
    fgSerialConfigManual = true;



}

void MainWindow::on_pB_conectar_clicked()
{
    serialCom->setPortName(ui->cB_puertos->currentText());//portCounter
    if (serialCom->open(QIODevice::ReadWrite)){
        if(fgSerialConfigManual == true){
            manualSerialConfig();
        }
        else{
            defaultSerialConfig();
        }
        QMessageBox::information(this, "Info Serial", "Conexión Serial OK!");
    }
    else {
        QMessageBox::warning(this, "Error Serial", "No se pudo conectar");
    }
}


void MainWindow::on_actionActuador_Analogo_triggered() {
    serialCom->write("s\n");//2000
    flag = false;
    ActuadorAnalogo->setLabels();
    ActuadorAnalogo->show();
}

//=======
/*
void MainWindow::digestSerialData()

//>>>>>>> Stashed changes
}
*/


void MainWindow::on_actionConfig_Actuador_Analogo_triggered() {
    std::string serv = "Servo";
    std::string mot = "Motor";
    std::string lled = "Leds";
    int returnConfigActuador;
    ConfigAnalogActuador newActuadorConfig(this); //= new ConfigAnalogSensorDialog(this);
    configuracionActuador = &newActuadorConfig;
    newActuadorConfig.setWindowTitle("Actuador");
    returnConfigActuador= newActuadorConfig.exec();
    if (returnConfigActuador == QDialog::Rejected)
        return;
    tipo_actuador = configuracionActuador->getTipoActuador();
    if (tipo_actuador==serv) {
       ActuadorAnalogo = new servoActuador(0,180,&serialCom);
    }
    else if(tipo_actuador==mot){
        ActuadorAnalogo = new motorActuador(0,20,&serialCom);
    }
    else if(tipo_actuador==lled){
        ActuadorAnalogo = new ledActuador(0,254,&serialCom);
    }

}

void MainWindow::on_pB_sensor_clicked()
{
    SensorAnalogo->setLabels();
    SensorAnalogo->show();
    flag = true;
/*<<<<<<< Updated upstream

=======

>>>>>>> Stashed changes
*/
}

void MainWindow::on_pB_actuator_clicked()
{
    serialCom->write("s\n");//2000
    flag = false;
    ActuadorAnalogo->setLabels();
    ActuadorAnalogo->show();
}
