#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <analogVoltage.h>
#include <AnalogSensor.h>
#include <configanalogsensordialog.h>
#include <configanalogactuador.h>
#include <HumedadSensor.h>
#include <LuzSensor.h>
#include <FuerzaSensor.h>
#include <CorrienteSensor.h>
#include <actuadorVoltage.h>
#include <servoActuador.h>
#include <motorActuador.h>
#include <ledActuador.h>
#include <serialconfigdialog.h>
#include <serialconfigdialog.h>
#include <QtSerialPort/QtSerialPort>
#include <QtSerialPort/QSerialPortInfo>


QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();
    QByteArray msg2snd_byteArray, msgRcvd_byteArray;
    QByteArray  msgRcvd;
    QVector<QString> *puertos = new QVector<QString>;
    bool fgSerialConfigManual = false;
    int bR, dB, pty, sB, fC, portCounter;//parametros de conf del puerto serial

    void defaultSerialConfig();
    void manualSerialConfig();
    void refreshAnalogSensor();

private slots:
    void on_actionActuador_Analogo_triggered();
    void on_actionSensor_An_logo_Gen_rico_triggered();
    void digestSerialData();
    //void quertyData();
    void on_actionConfigSensorAnalogo_triggered();
    void on_actionserial_triggered();
    //void recepcion_aplicacion();
    void on_pB_conectar_clicked();
    void on_actionConfig_Actuador_Analogo_triggered();

    void on_pB_sensor_clicked();

    void on_pB_actuator_clicked();

private:
    std::string tipo_sensor;
    std::string tipo_actuador;
    std::string periodo;
    Ui::MainWindow *ui;
    QSerialPort *serialCom;
    analogVoltage *SensorAnalogo;
    actuadorVoltage *ActuadorAnalogo;
    ConfigAnalogSensorDialog *configuracionSensor;
    QTimer *timerRefresh;
    ConfigAnalogActuador *configuracionActuador;
    bool flag;
    int delta;
};
#endif // MAINWINDOW_H
