/**
  * @file serialconfigdialog.cpp
  * @version 0.1
  * @date 17/02/2020
  * @author Sebastián Arriagada C.
  * @brief Clase serialConfigDialog que permite configurar los parámetros
  * de la comunicación serial en una nueva ventana.
  *
  */

#include "serialconfigdialog.h"
#include "ui_serialconfigdialog.h"

serialConfigDialog::serialConfigDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::serialConfigDialog)
{
    ui->setupUi(this);
    //Se configuran las oipciones de los comboBoxes
    //Se setean las opciones del baudRate
    ui->cB_baudRate->addItem("9600");//setItemText(0, "9600");
    ui->cB_baudRate->addItem("19200");//setItemText(1, "19200");
    ui->cB_baudRate->addItem("38400");//setItemText(2, "38400");
    ui->cB_baudRate->addItem("57600");//setItemText(3, "57600");
    ui->cB_baudRate->addItem("115200");//setItemText(4, "115200");
    //Se setean las opciones de DataBits
    ui->cB_dataBit->addItem("8");
    ui->cB_dataBit->addItem("5");
    ui->cB_dataBit->addItem("6");
    ui->cB_dataBit->addItem("7");
    //Se setean las opciones de Parity
    ui->cB_parity->addItem("No Parity");
    ui->cB_parity->addItem("Even Parity");
    ui->cB_parity->addItem("Odd Parity");
    ui->cB_parity->addItem("Space Parity");
    ui->cB_parity->addItem("Mark Parity");
    //Se setean las opciones de stop bit
    ui->cB_stopBit->addItem("One Stop");
    ui->cB_stopBit->addItem("Two Stop");
    ui->cB_stopBit->addItem("One And Half Stop");
    //Se setean las opciones de Flow Control
    ui->cB_flowControl->addItem("No Flow Control");
    ui->cB_flowControl->addItem("Hardware Control");
    ui->cB_flowControl->addItem("Software Control");

}

serialConfigDialog::~serialConfigDialog()
{
    delete ui;
}

int serialConfigDialog::getBaudRate()
{
    return (ui->cB_baudRate->currentText()).toInt();
}

int serialConfigDialog::getDatabit()
{
    return (ui->cB_dataBit->currentText()).toInt();
}

int serialConfigDialog::getParity()
{
    return ((ui->cB_parity->currentIndex() > 0) ? (ui->cB_parity->currentIndex() + 1) : ui->cB_parity->currentIndex());
}

int serialConfigDialog::getStopBit()
{
    return ((ui->cB_stopBit->currentIndex())+1);
}

int serialConfigDialog::getFlowControl()
{
    return (ui->cB_flowControl->currentIndex());
}


void serialConfigDialog::on_buttonBox_accepted()
{
    accept();
}

void serialConfigDialog::on_buttonBox_rejected()
{
    reject();
}

